import java.util.HashMap;
import squint.*;
import javax.swing.*;

/*
 * Class AddressMaker - Create and manage address cards
 */
public class AddressManager extends GUIManager
{
   // Change these values to adjust the size of the program's window
   private final int WINDOW_WIDTH  = 270, WINDOW_HEIGHT = 80;

   // Size of address field
   private final int ADDR_WIDTH = 15;
   
   // Name of person described by new address card
   private JTextField name = new JTextField( ADDR_WIDTH );
      
   // Menu used to select desired card
   private JComboBox names = new JComboBox();
   
   // Association between names and cards
   private HashMap<String,AddressCard> cards =
                           new HashMap<String, AddressCard>();
   
   /*
    *  Place text field, button, and menu in the window
    */
    public AddressManager() {
      // Create window to hold all the components
      this.createWindow( WINDOW_WIDTH, WINDOW_HEIGHT, "Make Address Card" );
   
      contentPane.add( new JLabel( "Name: " ) );
      contentPane.add( name );
      name.requestFocus();
      contentPane.add( names );
    }
   
   /*
    *  Create a new card or display existing card
    */
    public void textEntered( ) {
        String requestedName;
        AddressCard requestedCard;

        requestedName = name.getText();
        
        requestedCard = cards.get( requestedName );
        
        if ( requestedCard == null) {
            requestedCard = new AddressCard( requestedName );
            cards.put( requestedName, requestedCard );
            names.addItem( requestedName );
            
        } else {
            requestedCard.setVisible (true);
        }
        
        names.setSelectedItem( requestedName );
        name.setText("");
    }
    
   /*
    *  Choose an address card to display
    */
    public void menuItemSelected( ) {
        AddressCard desiredCard;
        desiredCard = cards.get( names.getSelectedItem() );
        desiredCard.setVisible( true );
    }
}
