
/*
 * Represents a mail message, providing easy access to its header fields 
 */
public class MailMessage
{
    // The contents of the message
    private String messageContents;

    // Create a new, empty mail message
    public MailMessage( ) {
        messageContents = "";
    }
    
    // Add a line to a mail message
    public void append( String newLine ) {
        messageContents = messageContents + newLine + "\n";
    }

    // Provide access to the entire message contents
    public String getText() {
        return messageContents;
    }
    
    // Extract the from header line
    public String getFrom() {
        int fromStart = messageContents.indexOf( "From:" );
        int fromEnd = messageContents.indexOf( "\n", fromStart );
        return messageContents.substring( fromStart + "From:".length(), fromEnd );
    }
        
}
